module Hawkei
  ##
  # Display formated log
  class FormatedLogger

    class << self

      def build(logger)
        return new(logger) if logger
        return new(Rails.logger) if defined?(Rails)

        new(::Logger.new(STDOUT))
      end

    end

    attr_reader :logger

    PREFIX = '[Hawkei]'.freeze
    METHODS = %i[debug info warn error].freeze

    def initialize(logger)
      @logger = logger
    end

    METHODS.each do |method|
      define_method(method) do |message|
        log(method, message)
      end
    end

    private

    def log(type, message)
      return unless configurations.log

      logger.send(type, "#{PREFIX} #{message}")
    end

    def configurations
      Hawkei.configurations
    end

  end
end
